﻿function setTicketAgeTextFromDate($element) {
    if ($element.data("dateutc") !== undefined) {
        var now = GetServerNowUtc();
        var date = moment.utc($element.data("dateutc"));
        var diff = now.diff(date);
        if (diff > 0) {
            var duration = moment.duration(diff);
            var localization_text = "";
            var number = 0;

            if (duration.asMinutes() < 1.5) {
                localization_text = "Localization_TicketAge_MinuteAgo";
            }
            else if (duration.asMinutes() < 50) {
                localization_text = "Localization_TicketAge_MinutesAgo";
                number = Math.round(duration.asMinutes());
            }
            else if (duration.asHours() < 1.5) {
                localization_text = "Localization_TicketAge_HourAgo";
            }
            else if (duration.asHours() < 23) {
                localization_text = "Localization_TicketAge_HoursAgo";
                number = Math.round(duration.asHours());
            }
            else if (duration.asDays() < 1.5) {
                localization_text = "Localization_TicketAge_DayAgo";
            }
            else if (duration.asDays() < 25) {
                localization_text = "Localization_TicketAge_DaysAgo";
                number = Math.round(duration.asDays());
            }
            else if (duration.asDays() < 45) {
                localization_text = "Localization_TicketAge_MonthAgo";
            }
            else if (duration.asDays() < 350) {
                localization_text = "Localization_TicketAge_MonthsAgo";
                number = Math.round(duration.asDays() / 30);
            }
            else if (duration.asDays() < 548) {
                localization_text = "Localization_TicketAge_YearAgo";
            }
            else {
                localization_text = "Localization_TicketAge_YearsAgo";
                number = Math.round(duration.asDays() / 365.25);
            }

            $element.text(eval(localization_text).replace("%1%", number));
        }
    }
}