﻿var mandate;
var $lastUl = null;

function InsertResultUl($ul, insertAsFirst) {
    if ($lastUl != null && $lastUl.is(':visible')) { //visible, protoze uz muze byt ten div removnuty, pokud se nedojede az po posledni hledani, nenastavi se lastUl = null
        if (insertAsFirst) {
            var $div = $("#autocomplete_div");
            $ul.prependTo($div);
        }
        else {
            $ul.insertAfter($lastUl);
        }
    }
    else {
        var $div = $("#autocomplete_div");
        $ul.prependTo($div);
    }

    if (!insertAsFirst) {
        $lastUl = $ul;
    }
}

function GetAutocomplete() {
    var $div = $("#autocomplete_div");
    var $searchInput = $("#search-input");

    var q = $searchInput.val();

    if (q.length >= 3) {
        if ($div.find('.loading-16').length == 0) {
            $div.prepend('<div class="loading-16"></div>');
        }

        if (!$div.is(':visible')) {
            $div.find("ul.result").remove();
            $div.slideDown();
        }

        $('#formSearchFor button[type="submit"]').prop('disabled', false);
        $("#autocomplete_div ul.not-found").hide();
        mandate = Math.random().toString(36).substring(7);
        LoadTickets(q, mandate);
    }
    else {
        $('#formSearchFor button[type="submit"]').prop('disabled', true);
        HideResult();
    }
}

function LoadTickets(q, myMandate) {

    $.post(
    RQ_URL + '/Tickets/SearchForTicketsAutocomplete',
    {
        searchText: q,
        top: 10,
    },
    function (data) {

        if (myMandate == mandate) {
            $(".autocomplete_ul_tickets").remove();

            if ($(data.Tickets).length > 0) {
                // creating list
                var $ul = $("<ul></ul>", { class: "autocomplete_ul_tickets result" });
                // append Tickets title
                $("<li></li>", { class: "main", text: Localization_Tickets }).appendTo($ul);
                var i = 0;

                $(data.Tickets).each(function () {
                    var $li = $("<li></li>", { class: "result" + (this.Closed ? " closed" : "") }).appendTo($ul);

                    var $info = $("<div></div>", { text: this.Info, class: "result-info" }).appendTo($li);
                    $("<span></span>", { text: this.Submitter, class: "result-info-submitter check-highlight" }).appendTo($info);

                    if (this.Customer != null) {
                        $info.append(', ');
                        $("<span></span>", { text: this.Customer, class: "result-info-customer" }).appendTo($info);
                    }

                    $info.append('<br/>');
                    $("<span></span>", { text: this.CreatedShort, class: "result-info-created", title: this.CreatedLong }).appendTo($info);
                    $info.append(', ');
                    $("<span></span>", { text: this.TicketREF, class: "result-info-ticketREF check-highlight" }).appendTo($info);

                    var $div_ticket = $("<div></div>", { class: "result-ticket" }).appendTo($li);
                    var $a = $("<a></a>", { href: this.Url }).appendTo($div_ticket);
                    $("<span></span>", { text: this.Subject, class: "result-subject check-highlight" }).appendTo($a);

                    if (this.HitTicketUserMessage) {
                        var $div_message = $("<div></div>", { class: "result-message" }).appendTo($li);
                        $("<i></i>", { class: "fa fa-commenting-o" }).appendTo($div_message);
                        $div_message.append(' ');
                        $("<span></span>", { text: this.MessageFullName, class: "check-highlight" }).appendTo($div_message);
                        $div_message.append(': ');
                        $("<span></span>", { text: this.MessageFocused, class: "check-highlight" }).appendTo($div_message);
                    }

                    i++;
                });

                if (data.IsNextPage) {
                    var $li = $("<li class=\"showmore\"></li>").appendTo($ul);
                    var $a_link = $("<a></a>", { href: "javascript:void(0);", text: Localization_ShowMore + '...' });

                    $a_link.click(function () {
                        $("#SearchType").val(1);
                        $('#formSearchFor').submit();
                    });

                    $a_link.prependTo($li);
                }

                var splitedText = $.map(q.trim().split(' '), function (n, i) { return n.replace(/^\"/, "").replace(/\"$/, ""); }).filter(function (obj) { return obj.length >= 2; });
                //$ul.find("li.result .check-highlight").removeHighlight();
                $.each(splitedText, function (index, text) {
                    $ul.find("li.result .check-highlight").highlight(text, true);
                });

                InsertResultUl($ul,false);
            }
        }
    },
    "json"
    )
    .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
    .done(function () {
        if (myMandate == mandate) {
            LoadStickyNotes(q, myMandate);
            //LoadKnowledgeBase(q, myMandate);
            /*var $div = $("#autocomplete_div");

            if ($("#autocomplete_div li.result").length == 0) {
                $("#autocomplete_div ul.not-found").show();
            }

            $div.find("div.loading-16").remove();
            $lastUl = null; //dalsi kolo od zacatku*/
        }
    });
}

function LoadStickyNotes(q, myMandate) {
   $.post(
   RQ_URL + '/Desktop/SearchForTicketStickyNoteAutocomplete',
   { searchText: q },
   function (data) {
       if (myMandate == mandate) {
           $(".autocomplete_ul_ticket_sticky_note").remove();

           if ($(data).length > 0) {
               // creating list
               var $ul = $("<ul></ul>", { class: "autocomplete_ul_ticket_sticky_note result" });

               // append customer title
               $("<li></li>", { class: "main customer-autocomplete", text: Localization_TicketStickyNote }).appendTo($ul);

               $(data).each(function () {
                   if (this.Text === "showmore") {

                       var $li = $("<li class=\"showmore\"><span>" + Localization_SearchBox_TotalTicketStickyNotes + ": " + this.Id + "<span></li>");
                       var $a_link = $("<a></a>", { href: "javascript:void(0);", text: Localization_ShowAll });

                       $a_link.click(function () {
                           $("#SearchType").val(6);
                           $('#formSearchFor').submit();
                       });

                       $a_link.prependTo($li);
                       $li.appendTo($ul);
                   }
                   else {
                       var $li = $("<li></li>", { class: "result" });
                       var $a = $("<a></a>", { href: this.Url, text: this.Text, title: this.Text, class: "result" }).appendTo($li);
                       $li.appendTo($ul);
                   }
               });

               $ul.find("li.result a.result").highlight(q, true);
               InsertResultUl($ul,false);
           }
       }
   },
   "json"
   )
   .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
   .done(function () {
       if (myMandate == mandate) { LoadCustomers(q, myMandate); }
   });
}

function LoadCustomers(q, myMandate) {
    $.post(
    RQ_URL + '/Desktop/SearchForCustomersAutocomplete',
    { searchText: q },
    function (data) {
        if (myMandate == mandate) {
            $(".autocomplete_ul_customers").remove();

            if ($(data).length > 0) {
                // creating list
                var $ul = $("<ul></ul>", { class: "autocomplete_ul_customers result" });

                // append customer title
                $("<li></li>", { class: "main customer-autocomplete", text: Localization_SearchBox_Customers }).appendTo($ul);

                $(data).each(function () {
                    if (this.Name === "showmore") {

                        var $li = $("<li class=\"showmore\"><span>" + Localization_SearchBox_TotalCustomers + ": " + this.Id + "<span></li>");
                        var $a_link = $("<a></a>", { href: "javascript:void(0);", text: Localization_ShowAll });

                        $a_link.click(function () {
                            $("#SearchType").val(3);
                            $('#formSearchFor').submit();
                        });

                        $a_link.prependTo($li);
                        $li.appendTo($ul);
                    }
                    else {
                        var $li = $("<li></li>", { class: "result" });
                        var $a = $("<a></a>", { href: this.Url, text: this.Name, title: this.Name, class: "result" }).appendTo($li);
                        $li.appendTo($ul);
                    }
                });

                $ul.find("li.result a.result").highlight(q, true);
                InsertResultUl($ul,false);
            }
        }
    },
    "json"
    )
    .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
    .done(function () {
        if (myMandate == mandate) { LoadKnowledgeBase(q, myMandate); }
    });
}

function LoadKnowledgeBase(q, myMandate) {
    $.post(
    RQ_URL + '/Desktop/SearchForKnowledgeBaseAutocomplete',
    { searchText: q },
    function (data) {
        if (myMandate == mandate) {
            $(".autocomplete_ul_articles").remove();

            if ($(data).length > 0) {
                // creating list
                var $ul = $("<ul></ul>", { class: "autocomplete_ul_articles result" });

                // append knowledgebase title
                $("<li></li>", { class: "main knowledgeBase-autocomplete", text: Localization_SearchBox_KnowledgeBase }).appendTo($ul);

                $(data).each(function () {
                    if (this.Title === "showmore") {

                        var $li = $("<li class=\"showmore\"><span class='right'>" + Localization_SearchBox_TotalArticles + ": " + this.Id + "<span></li>");
                        var $a_link = $("<a></a>", { href: "javascript:void(0);", text: Localization_ShowAll });

                        $a_link.click(function () {
                            $("#SearchType").val(4);
                            $('#formSearchFor').submit();
                        });

                        $a_link.prependTo($li);
                        $li.appendTo($ul);
                    }
                    else {
                        var $li = $("<li></li>", { class: "result" });
                        var $a = $("<a></a>", { href: this.Url, text: this.Title, title: this.Title, class: "result" }).appendTo($li);
                        $li.appendTo($ul);
                    }
                });

                var splitedText = $.map(q.trim().split(' '), function (n, i) { return n.replace(/^\"/, "").replace(/\"$/, ""); }).filter(function (obj) { return obj.length >= 2 });
                //$ul.find("li.result a").removeHighlight();
                $.each(splitedText, function (index, text) {
                    $ul.find("li.result a").highlight(text, true);
                });

                InsertResultUl($ul,false);
            }
        }
    },
    "json"
    )
    .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
    .done(function () {
        if (myMandate == mandate) { LoadDocuments(q, myMandate); }
    });
}

function LoadDocuments(q, myMandate) {
    $.post(
    RQ_URL + '/Desktop/SearchForDocumentsAutocomplete',
    { searchText: q },
    function (data) {       
        if (myMandate == mandate) {
            $(".autocomplete_ul_documents").remove();

            if ($(data).length > 0) {
                // creating list
                var $ul = $("<ul></ul>", { class: "autocomplete_ul_documents result" });

                // append documents title
                $("<li></li>", { class: "main", text: Localization_SearchBox_Documents }).appendTo($ul);

                $(data).each(function () {
                    if (this.FileName === "showmore") {

                        var $li = $("<li class=\"showmore\"><span>" + Localization_SearchBox_TotalDocuments + ": " + this.Id + "<span></li>");
                        var $a_link = $("<a></a>", { href: "javascript:void(0);", text: Localization_ShowAll });

                        $a_link.click(function () {
                            $("#SearchType").val(5);
                            $('#formSearchFor').submit();
                        });

                        $a_link.prependTo($li);
                        $li.appendTo($ul);
                    }
                    else {
                        var $li = $("<li></li>", { class: "result" });
                        var $a = $("<a></a>", { href: this.Url, text: this.FileName, title: this.FileName, class: "result" }).appendTo($li);
                        $li.appendTo($ul);
                    }
                });

                $ul.find("li.result a.result").highlight(q, true);
                InsertResultUl($ul,false);
            }
        }
    },
    "json"
    )
    .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
    .done(function () {
        if (myMandate == mandate) { LoadUsers(q, myMandate); }
    });
}

function LoadUsers(q, myMandate) {
    $.post(
        RQ_URL + '/Desktop/SearchForUsersAutocomplete',
        { searchText: q },
        function (data) {
            if (myMandate == mandate) {
                $(".autocomplete_ul_users").remove();

                if ($(data).length > 0) {
                    // creating list
                    var $ul = $("<ul></ul>", { class: "autocomplete_ul_users result" });

                    // append documents title
                    $("<li></li>", { class: "main", text: Localization_SearchBox_Users }).appendTo($ul);

                    $(data).each(function () {
                        if (this.FileName === "showmore") {

                            var $li = $("<li class=\"showmore\"><span>" + Localization_SearchBox_TotalUsers + ": " + this.Id + "<span></li>");
                            var $a_link = $("<a></a>", { href: "javascript:void(0);", text: Localization_ShowAll });

                            $a_link.click(function () {
                                $("#SearchType").val(8);
                                $('#formSearchFor').submit();
                            });

                            $a_link.prependTo($li);
                            $li.appendTo($ul);
                        }
                        else {
                            var $li = $("<li></li>", { class: "result" });
                            var $a = $("<a></a>", { href: this.Url == "" ? "javascript:void(0)" : this.Url, text: this.Name, title: this.Name, class: "result" }).appendTo($li);
                            $li.appendTo($ul);
                        }
                    });

                    $ul.find("li.result a.result").highlight(q, true);
                    InsertResultUl($ul,false);
                }
            }
        },
        "json"
    )
    .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
    .done(function () {
        if (myMandate == mandate) { LoadDpdPackages(q, myMandate); }
    });
}

//hledá se poslední ale dává se na první místo, zatím takto, pokud bude vadit musí se upravit a přeskládat volání metod
function LoadDpdPackages(q, myMandate) {
    $.post(
        RQ_URL + '/Tickets/SearchForDpdPackagesAutocomplete',
        { searchText: q },
        function (data) {
            if (myMandate == mandate) {
                $(".autocomplete_ul_dpd_packages").remove();

                if ($(data).length > 0) {
                    // creating list
                    var $ul = $("<ul></ul>", { class: "autocomplete_ul_dpd_packages result" });
                    // append Tickets title
                    $("<li></li>", { class: "main", text: "Zásilky" }).appendTo($ul);
                    var i = 0;

                    $(data).each(function () {
                        if (i == top) {
                            var $li = $("<li class=\"showmore\"></li>").appendTo($ul);
                            var $a_link = $("<a></a>", { href: "javascript:void(0);", text: Localization_ShowMore + '...' });

                            $a_link.click(function () {
                                $("#SearchType").val(7);
                                $('#formSearchFor').submit();
                            });

                            $a_link.prependTo($li);
                        }
                        else {
                            var $li = $("<li></li>", { class: "result" + (this.Closed ? " closed" : "") }).appendTo($ul);

                            var $info = $("<div></div>", { text: this.Info, class: "result-info" }).appendTo($li);
                            $("<span></span>", { text: this.Submitter, class: "result-info-submitter check-highlight" }).appendTo($info);

                            if (this.Customer != null) {
                                $info.append(', ');
                                $("<span></span>", { text: this.Customer, class: "result-info-customer" }).appendTo($info);
                            }

                            $info.append('<br/>');
                            $("<span></span>", { text: this.CreatedShort, class: "result-info-created", title: this.CreatedLong }).appendTo($info);
                            $info.append(', ');
                            $("<span></span>", { text: this.TicketREF, class: "result-info-ticketREF check-highlight" }).appendTo($info);

                            var $div_ticket = $("<div></div>", { class: "result-ticket" }).appendTo($li);
                            var $a = $("<a></a>", { href: this.Url }).appendTo($div_ticket);
                            $("<span></span>", { text: this.Subject, class: "result-subject check-highlight" }).appendTo($a);
                        }

                        i++;
                    });

                    var splitedText = $.map(q.trim().split(' '), function (n, i) { return n.replace(/^\"/, "").replace(/\"$/, ""); }).filter(function (obj) { return obj.length >= 2; });
                    //$ul.find("li.result .check-highlight").removeHighlight();
                    $.each(splitedText, function (index, text) {
                        $ul.find("li.result .check-highlight").highlight(text, true);
                    });

                    InsertResultUl($ul,true);
                }
            }
        },
        "json"
    )
    .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
    .done(function () {

        if (myMandate == mandate) {
            var $div = $("#autocomplete_div");

            if ($("#autocomplete_div li.result").length == 0) {
                $("#autocomplete_div ul.not-found").show();
            }

            $div.find("div.loading-16").remove();
            $lastUl = null; //dalsi kolo od zacatku
        }

    });
}


function HideResult() {
    $("#autocomplete_div").slideUp('fast');
}
